/*
 * Copyright (c) 1997 David J. Wilson.
 * All rights reserved.
 *      
 * Copyright (c) 1997 Philip R. Wilson.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of any co-contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
 * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: ansi_io.h,v 1.2 1997/06/09 06:48:16 prw Exp $
 */

#ifndef _ANSI_IO_H
#define _ANSI_IO_H

#ifndef __cplusplus
#ifndef BOOL
typedef enum { false = 0, true } bool;
#define BOOL
#endif
#endif
typedef enum { off = 0, on } toggle;

#define ERR (-1)

/* for aio_write() */
#define PIPECODES

#ifdef __linux__
extern struct termio t_save;
extern int timeout_val;
#endif

#ifdef __FreeBSD__
extern struct termios t_save;
extern int timeout_val;
#endif

#ifdef __cplusplus
extern "C" {
#endif
extern int colour(int); 
extern int aio_read(char *, int);
extern void aio_write(char *);
extern int echo_tog(toggle);
extern int cbreak(toggle);
extern int aio_on(void);
extern void aio_off(void);
extern void getch_timeout(int);
extern void clear_screen(void);
extern void high_ascii(bool);
extern int getch(void);
extern void gotoxy(int, int);
#ifdef __cplusplus
}
#endif  

#endif !_ANSI_IO_H
